package Grid::GPT::DepOrdering;
use Data::Dumper;
my %foo=undef();

sub dep_ordering{
#Takes a list of dep-package objects, returns a dependency ordered list...

my @zero_queue;
my %counts;
my %rev_deps;
my %objecthash;
my %deps;
my $self=shift;
my @package_list= @_;
my @depslist;
my @returnlist;


#First, fill in the rev_deps and dependencies reference counts
foreach $package (@package_list){
	my %dephash;
	if ($package->{'Package_Type'} eq 'src'){
		if (!defined $counts{$package->{'Name'}}){
			$counts{$package->{'Name'}}=0;
			$objecthash{$package->{'Name'}}=\$package;
		}
		for my $deptype ('compile', 'pkg_link', 'lib_link'){
			for my $dep (keys %{$package->{'Source_Dependencies'}->{$deptype}}){
				$dep =~ s/_$//;
				$dephash{$dep}=1;
			 }
		 }
	 }#end if src
	 if ($package->{'Package_Type'} ne 'src'){
			 $objecthash{$package->{'Name'}."_".$package->{'Package_Type'}}=\$package; 
		   if (!defined $counts{$package->{'Name'}."_".$package->{'Package_Type'}}){
		         $counts{$package->{'Name'}."_".$package->{'Package_Type'}}=0;
		   }
		for my $deptype ('Compile', 'Build_Link', 'Runtime_Link'){
			 for my $dep (keys %{$package->{'Binary_Dependencies'}->{$deptype}}){
			        $dep =~ s/_$//;
				#		$dep = $dep."_".$package->{'Type'};
				#print $package->{'Type'};  
			        $dephash{$dep}=1;
		         }
	          }
	  }#end if not src
			 
	foreach $dep (keys %dephash){ #($package->{dependencies}){
		$counts{$dep}=$counts{$dep}+1;
		push @{$rev_deps{$dep}},  $package->{'Name'};
		push @{$deps{$package->{'Name'}."_".$package->{'Package_Type'}}}, $dep;
	}

} #end foreach $package

	foreach $key (keys %counts){
		if ($counts{$key}==0) {
			push @zero_queue, $key;
		}
	}
#While there is something in the zero_queue, take the first element
#of the queue and put it into the (now ordered) depslist
while (scalar(@zero_queue)){
	$package= shift @zero_queue;
push  @depslist, $package;
foreach $rev (@{$deps{$package}}){
	if (defined $rev){
		$counts{$rev}--;
		if ($counts{$rev}==0) {
			push @zero_queue, $rev;
		}
	}
}
}
foreach my $dep (@depslist){
	if (defined $objecthash{$dep}){
		push @returnlist, $objecthash{$dep}
	}
}
#return @depslist;
return @returnlist;
}

sub new {
	         my $class  = shift;
	         my $self  = {
	                   %foo,
	                      };
									               $self->{'pkgobj'}=$pkgobj;
										           bless $self, $class;
											       return $self;
										       }
										        
										       END { }
